/*
 * SPDX-License-Identifier: GPL-2.0+
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 *
 * You can also choose to distribute this program under the terms of
 * the Unmodified Binary Distribution Licence (as given in the file
 * COPYING.UBDL), provided that you have satisfied its requirements.
 */

FILE_LICENCE ( GPL2_OR_LATER_OR_UBDL );

#include <stdint.h>
#include <stdio.h>

__attribute__ (( noreturn, section ( ".text.null_trap" ) ))
void null_function_trap ( void ) {
	void *stack;

	/* 128 bytes of NOPs; the idea of this is that if something
	 * dereferences a NULL pointer and overwrites us, we at least
	 * have some chance of still getting to execute the printf()
	 * statement.
	 */
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );
	__asm__ __volatile__ ( "nop ; nop ; nop ; nop" );

	__asm__ __volatile__ ( "movl %%esp, %0" : "=r" ( stack ) );
	printf ( "NULL method called from %p (stack %p)\n", 
		 __builtin_return_address ( 0 ), stack );
	DBG_HD ( stack, 256 );
	while ( 1 ) {}
}
