/*
 * SPDX-License-Identifier: GPL-2.0+
 *
 * Driver for Solarflare network controllers and boards
 * Copyright 2019 Solarflare Communications Inc.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 as published
 * by the Free Software Foundation, incorporated herein by reference.
 *
 * You can also choose to distribute this program under the terms of
 * the Unmodified Binary Distribution Licence (as given in the file
 * COPYING.UBDL), provided that you have satisfied its requirements.
 */
/* The code in this file allows using the dyncfg_accessors.[hc] code nearly
 * without any modifications.
 */
#ifndef _SFC_EF10_DYNCFG_SFGPXE_COMPAT_H
#define _SFC_EF10_DYNCFG_SFGPXE_COMPAT_H

FILE_LICENCE ( GPL2_OR_LATER_OR_UBDL );

#include <stdint.h>

/* Size in bytes of the 'tag' member of all TLV structures. */
#define TLV_STRUCT_TAG_SIZE 4
/* Size in bytes of the 'length' member of all TLV structures. */
#define TLV_STRUCT_LENGTH_SIZE 4
#define TLV_ITEM_NON_DATA_SIZE (TLV_STRUCT_TAG_SIZE + TLV_STRUCT_LENGTH_SIZE)

#define __maybe_unused __attribute__((unused))

struct sfgpxe_dev_info {
  uint32_t pci_device_id;
  unsigned pf_index;
  int port;
};

#endif
